#include <stdio.h>
#include <string.h>

struct POINT
{
  double w, x, y;
};

static POINT nul[100], fst[10000], scnd[10000];
int N, S = 0, F = 0;

void Do( POINT *Res, POINT *A, POINT *B )
{
  Res->w = A->y * B->x - B->y * A->x;
  Res->x = A->w * B->y - B->w * A->y;
  Res->y = A->x * B->w - B->x * A->w;
}

int IsOnLine( POINT *L, POINT *C )
{
  if (L->w * C->w + L->x * C->x + L->y * C->y == 0)
    return 1;
  return 0;
}

int main( void )
{
  int maxc = -1, c = 0, i, j, k;
  POINT tmp, maxp;

  freopen("lnp.in", "r", stdin);
  freopen("lnp.out", "w", stdout);

  scanf("%i", &N);
  for (i = 0; i < N; i++)
  {
    scanf("%lf %lf", &nul[i].x, &nul[i].y);
    nul[i].w = 1;
  }

  /* Count fst */
  for (i = 0; i < N; i++)
    for (j = i + 1; j < N; j++)
    {
      Do(&fst[F++], &nul[i], &nul[j]);
      if (fst[F - 1].x == 0 && fst[F - 1].y == 0)
        F--;
    }

  /* Count scnd */
  for (i = 0; i < F; i++)
    for (j = i + 1; j < F; j++)
    {
      Do(&scnd[S++], &fst[i], &fst[j]);
      if (scnd[S - 1].w == 0)
        S--;      
    }

  /* Count ans */
  for (i = 0; i < N; i++)
    for (j = 0; j < S; j++)
    {
      c = 0;
      Do(&tmp, &nul[i], &scnd[j]);
      if (tmp.w == 0)
        continue;
      for (k = 0; k < S; k++)
        if (IsOnLine(&tmp, &scnd[k]))
          c++;
      if (c > maxc || maxc == -1)
      {
        maxc = c;
        memmove(&maxp, &tmp, sizeof(maxp));
      }
    }
  if (maxc == -1)
  {
    tmp.w = 1;
    tmp.x = 1;
    tmp.y = 1;
    Do(&maxp, &nul[0], &tmp);
    printf("0\n");
  }
  else
    printf("%i\n", maxc);
  printf("%.0lf %.0lf %.0lf", maxp.x, maxp.y, maxp.w);


  fclose(stdin);
  fclose(stdout);
}
