#include <stdio.h>
#include <string.h>

#define MH 23917

static int H[MH][512];

int Hash( char *S, int K )
{
  int i, ret = 0;

  for (i = 0; i < K; i++)
    ret = (ret + S[i]) % MH;
  return ret % MH;
}

int main( void )
{
  char S[100001];
  int flag, runflag = 1, i, tmp, j, k;
  int hash, N, K;

  freopen("double.in", "r", stdin);
  freopen("double.out", "w", stdout);

  gets(S);
  scanf("%i", &K);
  N = (int)strlen(S); 

  hash = Hash(S, K);
  for (i = 0; i < N - K + 1 && runflag; i++)
  {
    /* If this string was in the text */
    if (H[hash][0] > 0)
    {
      tmp = H[hash][0]; 
      while (H[hash][0] > 0)
      {
        flag = 1;
        for (j = H[hash][H[hash][0]], k = i; j < H[hash][H[hash][0]] + K; j++, k++)
          if (S[j] != S[k])
            flag = 0;
        /* We have found it */ 
        if (flag)
        {
          for (j = H[hash][H[hash][0]]; j < H[hash][H[hash][0]] + K; j++)
            printf("%c", S[j]);
          runflag = 0;
          break;
        }
        H[hash][0]--;
      }
      H[hash][0] = tmp + 1;
    }
    else
      H[hash][H[hash][0]++] = i;
    hash -= S[i];
    hash += S[i + K];
  }
  if (runflag)
    printf("NONE");

  fclose(stdin);
  fclose(stdout);
}
